#include <volpack.h>

typedef struct {		         /* contents of a voxel */
    short normal;		         /*   encoded surface normal vector */
    unsigned char density;	   /*   original density */
    unsigned char gradient;	/*   original gradient */
} RawVoxel;

typedef struct {		         /* contents of a voxel */
    short normal;		         /*   encoded surface normal vector */
    unsigned short density;	/*   original density */
    unsigned char gradient;	/*   original gradient */
} RawShortVoxel;

RawVoxel *dummy_voxel;
RawShortVoxel *dummy_short_voxel;


/* volpack stuff */
#define BYTES_PER_VOXEL	sizeof(RawVoxel)	/* voxel size in bytes */
#define VOXEL_FIELDS	3	/* number of fields in voxel */
#define SHADE_FIELDS	2	/* number of fields used for shading
				   (normal and density); must be the
				   1st fields of RawVoxel */
#define CLSFY_FIELDS	2	/* number of fields used for classifying
				   (density and gradient); can be any fields
				   in the RawVoxel */

#define NORMAL_FIELD	0
#define DENSITY_FIELD	1
#define GRADIENT_FIELD	2

#define DENSITY_PARAM		0		/* classification parameters */
#define OCTREE_DENSITY_THRESH	4
#define GRADIENT_PARAM		1
#define OCTREE_GRADIENT_THRESH	4
#define OCTREE_BASE_NODE_SIZE	4

#define DAREA_WIDTH	512   			/* viewport size */
#define DAREA_HEIGHT	512

int bytesPerVoxel;
int normalOffset;
int normalSize;
int normalMax;
int densityOffset;
int densitySize;
int densityMax;
int gradientOffset;
int gradientSize;
int gradientMax;


